import processing.core.*; import processing.net.*; import procontroll.*; import java.io.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class joystick_server_2 extends PApplet {



ControllIO controll;
Joystick joystick;
Joystick[] joysticks = new Joystick[2];

int port = 5204;
boolean myServerRunning = true;
int textLine = 60;
String msg;
String[] directions = new String[2];
float x,y;

Server myServer;

public void setup() {
  size(120, 120);

  controll = ControllIO.getInstance(this);
  int num=controll.getNumberOfDevices();
  //joystick=new Joystick(controll.getDevice(2), 0);
  for (int z=2; z<num; z++) {
    joysticks[z-2] = new Joystick(controll.getDevice(z), z-2);
  }
  myServer = new Server(this, port); // Starts a myServer on port 'port'
  background(0);
}

public void stop() {
  // If the mouse clicked the myServer stops
  myServer.stop();
  myServerRunning = false;
}

public void draw() {
  if (myServerRunning == true)
  {
    // ******************
    // f\u00fcr zwei Joysticks
    
    String s_msg="<?xml version='1.0' ?><ctrl>";
    boolean sendit=false;
    for (int z=0; z<joysticks.length; z++) {
     if (joysticks[z].needUpdate()) {
      s_msg += joysticks[z].getCompleteXML();
      sendit=true;
     }
    }
    if (sendit) {
      s_msg += "</ctrl>\0";
      myServer.write(s_msg);
      fill(random(10)*20);
      rect(50,50,20,20);
    }
    
    // ***************
    // f\u00fcr ein Joystick
    /*
    if (joystick.needUpdate()) {
      background(100);
      msg="<?xml version='1.0' ?><ctrl>"+joystick.getCompleteXML()+"</ctrl>\0";
      myServer.write(msg);
    }
    */
  } 
}



class Joystick {
  ControllDevice device;
  ControllSlider sliderX;
  ControllSlider sliderY;
  ControllStick stick;
  ControllButton button2, button1;
  int num;
  boolean last_state=false;
  Joystick( ControllDevice device, int num) {
    this.device=device;
    this.num=num;
    this.device.setTolerance(0.1f);
    this.sliderX = this.device.getSlider("X-Achse");
    this.sliderY = this.device.getSlider("Y-Achse");
    this.stick = new ControllStick(this.sliderX,this.sliderY);
    
    this.button1 = this.device.getButton(1);
    this.button2 = this.device.getButton(0);
  }
  
  public boolean needUpdate() {
    boolean out=false;
    if (this.stick.getY() != 0 || this.stick.getX() != 0 || this.button1.pressed()||this.button2.pressed()) {
      out=true;
    }
    if (this.last_state && !out) {
      this.last_state=out;
      out=true;
    }
    else {
      this.last_state=out;
    }
    return out;
  }

  public String isUp() {
    return this.stick.getY() < 0 ? "1" : "0";
  }
  public String isDown() {
    return this.stick.getY() > 0 ? "1" : "0";
  }
  public String isLeft() {
    return this.stick.getX() < 0 ? "1" : "0";
  }
  public String isRight() {
    return this.stick.getX() > 0 ? "1" : "0";
  }
  public String buttonPressed() {
    String out="0";
    if (this.button2.pressed())
      out="1";
    
    if (this.button1.pressed())
      out="1";
    
    return out;
  }
  public String getCompleteXML() {
    String out="<joystick_"+this.num;
     out+=" num='"+this.num+"'";
     out+=" up='"+this.isUp()+"'";
     out+=" down='"+this.isDown()+"'";
     out+=" left='"+this.isLeft()+"'";
     out+=" right='"+this.isRight()+"'";
     out+=" pressed='"+this.buttonPressed()+"' />\n";
     return out;
  }
}
static public void main(String args[]) {   PApplet.main(new String[] { "joystick_server_2" });}}